package smartresource.abb;

import smartresource.core.*;

import javax.swing.*;
import java.awt.*;

import java.util.Calendar;
import java.util.Vector;
import java.util.Iterator;

import jade.gui.GuiEvent;

public class ExpertAgentGUI extends SmartResourceAgentGUI
{
	JLabel label1;
	JLabel label2;
	JButton requestButton;
	JButton fixButton;
	JButton geoButton;
	JButton locButton;
  
	public void construct(){

		Container pane=getContentPane();
		setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));

		label1 = new JLabel(". . .");	
		label2 = new JLabel("");	
		label2.setForeground(Color.red);
		requestButton = new JButton("Show network in GoogleEarth");
		fixButton = new JButton("Send maintenance crew");
		fixButton.setEnabled(false);
		geoButton = new JButton("Show network in GML");
		locButton = new JButton("Request localization service");
		locButton.setEnabled(false);

		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(label2);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(label1);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(geoButton);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(requestButton);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(locButton);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		pane.add(fixButton);
		pane.add(Box.createRigidArea(new Dimension(0,10)));

		ActList aActList = new ActList();
		requestButton.addActionListener(aActList);
		fixButton.addActionListener(aActList);
		geoButton.addActionListener(aActList);
		locButton.addActionListener(aActList);

		pack();
	        setSize((int)getSize().getWidth()+20,(int)getSize().getHeight()+10);
	}

	public void modify(){

		String event=getParameterValue("modify");
		String str=getParameterValue("value");

		if(event.equals("DataLabel")){
			Calendar now=Calendar.getInstance();
			String time=String.valueOf(now.get(Calendar.HOUR_OF_DAY))+":"+String.valueOf(now.get(Calendar.MINUTE))+":"+String.valueOf(now.get(Calendar.SECOND));
       			label1.setText(str+" "+time);
		}
		else if(event.equals("AlertLabel")){
			Calendar now=Calendar.getInstance();
			String time=String.valueOf(now.get(Calendar.HOUR_OF_DAY))+":"+String.valueOf(now.get(Calendar.MINUTE))+":"+String.valueOf(now.get(Calendar.SECOND));
       			label2.setText(str+" "+time);
		}
		else if(event.equals("ButtonOn")){
			fixButton.setEnabled(true);
			locButton.setEnabled(true);
		}
		else if(event.equals("ButtonOff")){
			fixButton.setEnabled(false);
			locButton.setEnabled(false);
       			label2.setText(" ");
		}
	}


	class ActList implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object==geoButton){
				GuiEvent ev = new GuiEvent(this, 0);
				ev.addParameter("User Clicked GML");
				myAgent.postGuiEvent(ev);
			}
			if (object==requestButton){
				GuiEvent ev = new GuiEvent(this, 0);
				ev.addParameter("User Clicked Google");
				myAgent.postGuiEvent(ev);
			}
			else if (object==fixButton){
				GuiEvent ev = new GuiEvent(this, 0);
				ev.addParameter("User Clicked Maintenance");
				myAgent.postGuiEvent(ev);
			}
			else if (object==locButton){
				GuiEvent ev = new GuiEvent(this, 0);
				ev.addParameter("User Clicked Localization");
				myAgent.postGuiEvent(ev);
			}
		}
	}

}
