package smartresource.core.behaviors;

import smartresource.core.*;

import java.util.Vector;

import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;


public class DFLookupBehavior extends ReusableAtomicBehavior{

   public void action() {

	String role=getParameterValue("search");
	String noneBelief=getParameterValue("addIfNone");
	String oneBelief=getParameterValue("addIfOne");
	String severalBelief=getParameterValue("storeIfSeveral");
	Vector addSevBeliefs=getParameterValues("addIfSeveral");

        DFAgentDescription template = new DFAgentDescription();
        ServiceDescription sd = new ServiceDescription();
        sd.setName(role);
        template.addServices(sd);
        try {
        	DFAgentDescription[] result = DFService.search(myAgent, template); 
		if(result.length==0){
			print(role+" was not found in DF!");
			if(noneBelief!=null){
				SemanticStatement ss=new SemanticStatement(noneBelief);
				addBelief(ss);
			}
		}                                            	
		else if(result.length==1){
			oneBelief.equals(""); //to cause exception if null
	
			String name=result[0].getName().getLocalName();
			SemanticStatement ss=new SemanticStatement(oneBelief);
			ss.object=name;
			addBelief(ss);
		}
		else{ 
		   for(int i=0; i<result.length; i++){
			severalBelief.equals(""); //to cause exception if null

			String name=result[i].getName().getLocalName();
			SemanticStatement ss=new SemanticStatement(severalBelief);
			ss.object=name;
			addBelief(ss);
		   }
                   for(int i=0; i<addSevBeliefs.size();i++)
			addBelief(new SemanticStatement((String)addSevBeliefs.elementAt(i)));
		}

        }
	catch (FIPAException fe) {
		fe.printStackTrace();
		success=false;
	}

   }
}
