package smartresource.shared;

import smartresource.core.*;

import java.io.*;
import java.util.StringTokenizer;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

public class DataReceiverBehavior extends ReusableAtomicBehavior{

	String convID="";
	String data="";
	String onto="";
	String maxWait="";
	String addBeliefs="";

	long waitTill=0;

	public void onStart(){
		convID=getParameterValue("conversationID");
		data=getParameterValue("saveTo");
		onto=getParameterValue("datatype");
		maxWait=getParameterValue("maxWait");
		if(maxWait!=null){
			long toWait=new Long(maxWait).longValue();
			long now=System.currentTimeMillis();
			waitTill=now+toWait;
		}
		addBeliefs=getParameterValue("addBeliefs");
		if(addBeliefs==null) addBeliefs="false";
	}

	public void action() {
		data.equals(""); //to cause exception if null
		convID.equals(""); //to cause exception if null
		onto.equals(""); //to cause exception if null

	        finished=false;

		StringTokenizer otoken=new StringTokenizer(onto, " ");
		MessageTemplate mt_onto=MessageTemplate.MatchOntology(otoken.nextToken());
		while(otoken.hasMoreTokens()){
			mt_onto=MessageTemplate.or(mt_onto,MessageTemplate.MatchOntology(otoken.nextToken()));
		}

		MessageTemplate mt=MessageTemplate.and(MessageTemplate.MatchConversationId(convID),mt_onto);
		ACLMessage msg = myAgent.receive(mt);
		if (msg!=null) {
			String enc = msg.getEncoding(); //sent "x of N"
			StringTokenizer token=new StringTokenizer(enc, " of ");
			String part=token.nextToken();
			String of=token.nextToken();

			String received_onto=msg.getOntology();
			
			String message=msg.getContent();
			try{
				
				File datafile=new File(data);
				String name=datafile.getName();
				int ind=name.indexOf(".");
				if(ind==-1) datafile=new File(data+received_onto);

		        	File p=datafile.getParentFile();
		        	if(p!=null && !p.exists()) p.mkdirs();

				if(!(received_onto.equals(".class") || received_onto.equals(".zip"))){
					FileWriter fwrite;
					if(part.equals("1")) fwrite=new FileWriter(datafile, false);
					else fwrite=new FileWriter(datafile, true);
					BufferedWriter ff=new BufferedWriter(fwrite);
					ff.write(message,0,message.length());
					ff.close();
				}
				else{
					BufferedOutputStream ff;
					if(part.equals("1")) ff=new BufferedOutputStream(new FileOutputStream(datafile, false));
					else ff=new BufferedOutputStream(new FileOutputStream(datafile,true));
					int bufferLength=message.length()/2;
					byte[] buffer = new byte[bufferLength];
					for (int i=0; i<bufferLength; i++){
					      int digit = Integer.parseInt(message.substring(i*2,i*2+2), 16);
					      buffer[i] = (byte)digit;
					}
					ff.write(buffer);
					ff.close();
				}

			}catch(IOException e){
				e.printStackTrace(); 
			   	success=false;
				return;
			}
			
			if(part.equals(of)){
				finished=true;
			        if(addBeliefs.equals("true")){ 
					long curr=System.currentTimeMillis();
					String requestId="request"+curr;
	                	
					addBelief(new SemanticStatement(requestId,"conversationID",convID));
					addBelief(new SemanticStatement(requestId,"sender",msg.getSender().getLocalName()));
					addBelief(new SemanticStatement(requestId,"inform",data));
					addBelief(new SemanticStatement(requestId,"ontology",received_onto));
				}
				print(received_onto+" from "+msg.getSender().getLocalName()+" received");
			} 	

		}
		else {
		        if(maxWait!=null){
				long now=System.currentTimeMillis();
				if(now>=waitTill){
				        success=false;
					finished=true;
				}
				else block(waitTill-now);
			}
			else block();
		}
	}
}
