package smartresource.shared;

import smartresource.core.*;

import java.io.*;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.core.AID;

public class DataSenderBehavior extends ReusableAtomicBehavior{

	public void action(){
		String receiver=getParameterValue("receiver");
		receiver.equals(""); //to cause exception if null
		String data=getParameterValue("loadFrom");
		data.equals(""); //to cause exception if null

		String addBeliefs=getParameterValue("addBeliefs");
		if(addBeliefs==null) addBeliefs="false";

		String conversation=getParameterValue("conversationID");
		if(conversation==null){
			long curr=System.currentTimeMillis();
			conversation=myAgent.getLocalName()+"_inform"+curr;
		}
		
                File datafile=new File(data);
		int len=(int)datafile.length();

		String ontology=data.substring(data.lastIndexOf("."));

		try{
			if(!(data.endsWith(".class") || data.endsWith(".zip"))){
				char mess[]=new char[len];

	                     	InputStreamReader iread=new InputStreamReader(new FileInputStream(datafile));
				BufferedReader ff=new BufferedReader(iread);
				int read=ff.read(mess,0,len);
				String message=new String(mess,0,read);
		
				ACLMessage m = new ACLMessage(ACLMessage.INFORM);
				m.addReceiver(new AID(receiver, AID.ISLOCALNAME));
				m.setConversationId(conversation);
				m.setContent(message);
				m.setOntology(ontology); //misuse - extension of file
				m.setEncoding("1 of 1"); //misuse - part
				myAgent.send(m);

				ff.close();
			}
			else{
	                     	BufferedInputStream ff=new BufferedInputStream(new FileInputStream(datafile));
				byte mess[]=new byte[len];
				int read=ff.read(mess,0,len);
				StringBuffer hexData = new StringBuffer();
				for (int j=0; j<read; j++){ 
					String hex=Integer.toHexString(0xff & mess[j]);
					if(hex.length()==1) hex="0"+hex;
					hexData.append(hex);
				}
				String message=hexData.toString();

				ACLMessage m = new ACLMessage(ACLMessage.INFORM);
				m.addReceiver(new AID(receiver, AID.ISLOCALNAME));
				m.setConversationId(conversation);
				m.setContent(message);
				m.setOntology(ontology); //misuse - extension of file
				m.setEncoding("1 of 1");  //misuse - part
				myAgent.send(m);

				ff.close();
			}	

			if(addBeliefs.equals("true")){
				long curr=System.currentTimeMillis();
				String requestId=myAgent.getLocalName()+"_inform"+curr;
				addBelief(new SemanticStatement(requestId,"conversationID",conversation));
				addBelief(new SemanticStatement(requestId,"receiver",receiver));
				addBelief(new SemanticStatement(requestId,"inform",data));
				addBelief(new SemanticStatement(requestId,"ontology",ontology));
			}
			//print(datafile+" sent");

		}catch(IOException e){
			e.printStackTrace();
			success=false;
		}

	}
  }
