package smartresource.shared;

import smartresource.core.*;

import java.util.Iterator;
import java.io.FileInputStream;

import org.apache.poi.hssf.usermodel.*;

public class ExcelReaderBehavior extends ReusableAtomicBehavior{

	private String getValue(HSSFCell cell){
	        if(cell==null) return null;
		int type=cell.getCellType();
		String value;
		if(type==HSSFCell.CELL_TYPE_NUMERIC || type==HSSFCell.CELL_TYPE_FORMULA)
			value=new Double(cell.getNumericCellValue()).toString();
		else 
			value=cell.getStringCellValue();
		return value;
	}

	
	public void action() {
		String filename=getParameterValue("input");
		filename.equals(""); //to cause exception if null

		try{
			HSSFWorkbook workbook = new HSSFWorkbook(new FileInputStream(filename));
			HSSFSheet sheet = workbook.getSheetAt(0); 

			int RN=sheet.getLastRowNum();
			
			HSSFRow row = sheet.getRow(0);

			short RC=row.getLastCellNum();
			String labels[]=new String[RC];

			for(short iCol=0; iCol<RC;iCol++)
				labels[iCol]=getValue(row.getCell(iCol));
			
			long curr=System.currentTimeMillis();
			String id="ws"+curr;

			for(int iRow=1; iRow<=RN;iRow++){
				row = sheet.getRow(iRow);
				String rid=id+"_"+iRow;
	
	                        addBelief(new SemanticStatement(filename,"Row",rid));
				
				for(short iCol=0; iCol<RC;iCol++){
				        if(labels[iCol]!=null){
						HSSFCell cell = row.getCell(iCol); 
						String value=getValue(cell);
						if(value==null) value=("");
			                        addBelief(new SemanticStatement(rid,labels[iCol],value));
			                }
				}
				
			}
			
		}
		catch(Exception ex){
			ex.printStackTrace();
			success=false;
		}
	
	}
}
