package smartresource.shared;

import smartresource.core.*;

import jade.lang.acl.ACLMessage;
import jade.core.AID;

public class RequestSenderBehavior extends ReusableAtomicBehavior{

	public void action(){
		String receiver=getParameterValue("receiver");
		receiver.equals(""); //to cause exception if null
		String request=getParameterValue("request");
		request.equals(""); //to cause exception if null

		String conversation=getParameterValue("conversationID");
		String performative=getParameterValue("performative");
		if(performative==null) performative="request";
		int perform;
		if(performative.equals("inform")) perform=ACLMessage.INFORM;
		else perform=ACLMessage.REQUEST;

		String requestParam=getParameterValue("parameter");
		String addBeliefs=getParameterValue("addBeliefs");
		if(addBeliefs==null) addBeliefs="true";

		ACLMessage message=new ACLMessage(perform);
		message.addReceiver(new AID(receiver, AID.ISLOCALNAME));
		message.setContent(request);

		long curr=System.currentTimeMillis();

		String requestId=myAgent.getLocalName()+"_request"+curr;
		if(conversation==null) conversation=requestId;
        
	        message.setConversationId(conversation);
		if(requestParam!=null && !requestParam.equals("")) message.addUserDefinedParameter("requestParameter", requestParam);
		myAgent.send(message);

		while(System.currentTimeMillis()==curr) myAgent.doWait(2);

		if(addBeliefs.equals("true")){
			addBelief(new SemanticStatement(requestId,"conversationID",conversation));
			addBelief(new SemanticStatement(requestId,"performative",performative));
			addBelief(new SemanticStatement(requestId,"receiver",receiver));
			addBelief(new SemanticStatement(requestId,"request",request));
			addBelief(new SemanticStatement(requestId,"parameter",requestParam));
		}
	}
  }
