package smartresource.shared;

import smartresource.core.*;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

public class ResponseReceiverBehavior extends ReusableAtomicBehavior{

	String convID="";
	String saveTo="";
	String maxWait="";
	String addBeliefs="";

	long waitTill=0;

	public void onStart(){
		convID=getParameterValue("conversationID");
		saveTo=getParameterValue("saveTo");

		maxWait=getParameterValue("maxWait");
		if(maxWait!=null){
			long toWait=new Long(maxWait).longValue();
			long now=System.currentTimeMillis();
			waitTill=now+toWait;
		}

		addBeliefs=getParameterValue("addBeliefs");
		if(addBeliefs==null) addBeliefs="false";
	}

	public void action() {
		saveTo.equals(""); //to cause exception if null
		convID.equals(""); //to cause exception if null
	        
	        finished=false;

		ACLMessage msg = myAgent.receive(MessageTemplate.MatchConversationId(convID));
		if (msg!=null) {
			String message=msg.getContent();
			print("\""+message+"\" from "+msg.getSender().getLocalName()+" received");

			SemanticStatement ss_output=new SemanticStatement(saveTo);
			if(ss_output.isSubjectUndefined()) ss_output.subject=message;
			if(ss_output.isPredicateUndefined()) ss_output.predicate=message;
			if(ss_output.isObjectUndefined()) ss_output.object=message;
			addBelief(ss_output);
			finished=true;

		        if(addBeliefs.equals("true")){ 
				long curr=System.currentTimeMillis();
				String requestId="request"+curr;
	
				addBelief(new SemanticStatement(requestId,"conversationID",convID));
				addBelief(new SemanticStatement(requestId,"sender",msg.getSender().getLocalName()));
				addBelief(new SemanticStatement(requestId,"inform",message));
			}
		}
		else {
		        if(maxWait!=null){
				long now=System.currentTimeMillis();
				if(now>=waitTill){
				        success=false;
					finished=true;
				}
				else block(waitTill-now);
			}
			else block();
		}
	}
}
